% Puting Introduction
# Puting Introduction
<style>
h1 { text-align: center; }
p + p { text-indent: 2em; }
</style>

<div style='text-align:center'>
<figure>
<svg width='256' height='256'>
<defs>
<linearGradient id='g0' x1='0' x2='0.700' y1='0' y2='1.212'>
<stop offset='0' stop-color='#fc9' />
<stop offset='1' stop-color='#630' />
</linearGradient>
</defs>
<polygon points='231,68 128,8 24,68 24,188 127,248 231,188'
         fill='url(#g0)'
         stroke='white' stroke-width='8' />
<circle cx='128' cy='128' r='45' fill='#333' />
</svg>
<figcaption aria-hidden="true">Puting icon</figcaption>
</figure>
</div>

## What is this document
This document provides an overview of Puting
and a brief introduction to its operation.


## What is Puting
*Puting* is a hex editor,
software to view and edit any file as a sequence of hexadecimal bytes.

Puting uses vi-like key bindings (in particular, prefix arguments)
common in Unix, allowing easy access to a wide variety of functions.

Instantly opens even large files to show their contents.

Also provides a colour-coded visual representation of the bytes.
This display is compact and provides a broad overview.

Puting is individually developed software
and is in the early stages of development. Feedback is welcome.
This software is provided under an MIT/X-style license
and is therefore free software.

## What does it look like
The left side of the Puting screen contains the editing area,
while the right side displays details.

In the figure below,
the screen is reduced in size to show only the left side area.

<div style='text-align:center'>
![screen shot](screenshot.png)
</div>

The offset position from the beginning of the file is displayed
on the left edge of the screen.
To the right of that,
the raw data is displayed in bytes, 16 bytes per line.

## System requirement

Puting runs on Windows 11.

## Keybind
- `jklh` move cursor
- `0-9` set number prefix (e g `4l` move cursor 4 byte right)
- `<>` or `gG` move cursor to top / bottom in the file
- `HML` move cursor to top / middle / bottom in current screen
- `irx` insert / replace / delete a byte
- `/?` search a number forward / backward
- `*#` search the number at cursor forward / backward
- `n` search next
- `^f` `^b` scroll down / up
- `^m` put mark at cursor
- and more...

## Mouse operation
Drag and drop a file into the Puting window to open it.
Clicking on any byte position moves the cursor to that position.
Selecting a byte sequence by dragging it with the mouse immediately
copies the byte sequence to the clipboard as a string representation.
By clicking and dragging with the right mouse button,
the selection can be extended or reduced.
Scrolling can be performed by turning the mouse wheel.
